﻿Imports System.Collections.ObjectModel
Imports DlhSoft.Windows.Data

Class Window1

    Public Sub New()

        InitializeComponent()

        ' Prepare the resource data collection.
        Dim resourceItems As New ObservableCollection(Of ResourceItem)
        resourceItems.Add(New ResourceItem With {.Content = "Resource 1", .CostPerUsage = 100, .CostPerHour = 10})
        resourceItems.Add(New ResourceItem With {.Content = "Resource 2", .CostPerHour = 20})
        resourceItems.Add(New ResourceItem With {.Content = "Resource 3", .CostPerHour = 20})

        ' Prepare the assignable task data collection.
        Dim assignableTaskItems As New ObservableCollection(Of TaskItem)
        assignableTaskItems.Add(New TaskItem With {.Content = "Task 1", .IndexString = "1"})
        assignableTaskItems.Add(New TaskItem With {.Content = "Task 1.1", .Indentation = 1, .Start = DateTime.Today, .Effort = TimeSpan.Parse("08:00:00"), .CompletedEffort = TimeSpan.Parse("04:00:00"), .IndexString = "2"})
        assignableTaskItems.Add(New TaskItem With {.Content = "Task 1.2", .Indentation = 1, .IndexString = "3"})
        assignableTaskItems.Add(New TaskItem With {.Content = "Task 1.2.1", .Indentation = 2, .Start = DateTime.Today, .Effort = TimeSpan.Parse("08:00:00"), .IndexString = "4"})
        assignableTaskItems.Add(New TaskItem With {.Content = "Task 1.2.2", .Indentation = 2, .Start = DateTime.Today, .Effort = TimeSpan.Parse("16:00:00"), .IndexString = "5"})
        assignableTaskItems.Add(New TaskItem With {.Content = "Task 2", .IsExpanded = True, .IndexString = "6"})
        assignableTaskItems.Add(New TaskItem With {.Content = "Task 2.1", .Indentation = 1, .Start = DateTime.Today, .Effort = TimeSpan.Parse("16:00:00"), .IsCompleted = True, .IndexString = "7"})
        assignableTaskItems.Add(New TaskItem With {.Content = "Task 2.2", .Indentation = 1, .Start = DateTime.Today, .Effort = TimeSpan.Parse("08:00:00"), .CompletedEffort = TimeSpan.Parse("06:00:00"), .IndexString = "8"})
        assignableTaskItems.Add(New TaskItem With {.Content = "Task 2.3", .Indentation = 1, .IsExpanded = True, .IndexString = "9", .PredecessorsString = "8"})
        assignableTaskItems.Add(New TaskItem With {.Content = "Task 2.3.1", .Indentation = 2, .Start = DateTime.Today, .Effort = TimeSpan.Parse("1.16:00:00"), .IndexString = "10", .Cost = 2000})
        assignableTaskItems.Add(New TaskItem With {.Content = "Task 2.3.2", .Indentation = 2, .Start = DateTime.Today, .Effort = TimeSpan.Parse("08:00:00"), .IndexString = "11", .PredecessorsString = "10"})
        assignableTaskItems.Add(New TaskItem With {.Content = "Task 3", .Start = DateTime.Today, .Effort = TimeSpan.Parse("12:30:00"), .CompletedEffort = TimeSpan.Parse("02:30:00"), .IndexString = "12", .PredecessorsString = "9, 11SS+12"})
        assignableTaskItems.Add(New TaskItem With {.Content = "Task 4", .Start = DateTime.Today, .Effort = TimeSpan.Parse("16:00:00"), .AssignmentsString = "Resource 1", .IndexString = "13"})
        assignableTaskItems.Add(New TaskItem With {.Content = "Task 5", .Start = DateTime.Today, .Effort = TimeSpan.Parse("20:00:00"), .AssignmentsString = "Resource 1, Resource 2 [50%]", .IndexString = "14"})
        assignableTaskItems.Add(New TaskItem With {.Content = "Task 6", .Start = DateTime.Today, .IsMilestone = True, .IndexString = "15", .PredecessorsString = "14+2"})
        assignableTaskItems.Add(New TaskItem With {.Content = "Task 7", .Start = DateTime.Today, .Effort = TimeSpan.Parse("16:00:00"), .CompletedEffort = TimeSpan.Parse("08:00:00"), .AssignmentsString = "Resource 1", .IndexString = "16", .PredecessorsString = "15+2"})
        assignableTaskItems.Add(New TaskItem With {.Content = "Task 8", .Start = DateTime.Today, .Effort = TimeSpan.Parse("16:00:00"), .AssignmentsString = "Resource 1", .IndexString = "17", .PredecessorsString = "16"})
        assignableTaskItems.Add(New TaskItem With {.Content = "Task 9", .Start = DateTime.Today, .Effort = TimeSpan.Parse("16:00:00"), .AssignmentsString = "Resource 2", .IndexString = "18", .PredecessorsString = "16"})
        assignableTaskItems.Add(New TaskItem With {.Content = "Task 10", .Start = DateTime.Today, .Effort = TimeSpan.Parse("16:00:00"), .AssignmentsString = "Resource 2, Resource 3 [75%]", .IndexString = "19", .PredecessorsString = "18"})

        ' Set the ItemsSource to the prepared resource data collection.
        LoadChartResourceListView.ItemsSource = resourceItems
        ' Set the AssignableTaskItemsSource to the prepared assignable task data collection.
        LoadChartResourceListView.AssignableTaskItemsSource = assignableTaskItems

    End Sub

End Class
